import 'package:couchbase_lite/couchbase_lite.dart';
import 'package:demo_caja_dart/pos_sqlite.dart';

class Activo {
  String nombre;
  double precio;
  String sku;
  String tienda_id;
}
enum Modo {
  ONLINE,
  OFFLINE
}

class POS {
  String _token;
  Modo modo;
  String host;
  String _bucket;
  Database _db;


  POS(this._token, [this.modo=Modo.OFFLINE]);

  void _login(String user, String pwd, [String endpoint]) async{
    //    Abrir socket sqlite
    POS_sqlite db = POS_sqlite(this._token);
    if (modo == Modo.OFFLINE){
      bool exito = await db.abrirConexion(user, pwd);
      if (exito){

      }
    }else if(modo == Modo.ONLINE){
      //Consultar API usando endpoint
      Map<String, String> data= {"name": user, "password": pwd, "token": this._token};

      bool exito = true;
      if (exito){
        Map<String,String> jsonResponse = {};

      }
    }
//
//
//    if (await abrirDB(dbName)){
//
//    }
  }
  Future<bool> abrirDB(String dbName) async{
    try {
      this._db = await Database.initWithName(dbName);
      return true;
    }on Exception {
      return false;
    }
  }
  Future<ReplicatorConfiguration> replicate(String sessionId,
      [dbName = "maestro_precios", type = ReplicatorType.pushAndPull, bool ssl=false]) async {
    String scheme = "ws";
    scheme = "${scheme}s"; if (ssl)

    this._db = await Database.initWithName(dbName);
    ReplicatorConfiguration config = new ReplicatorConfiguration(
        this._db, "${scheme}://${this.host}/${this._bucket}");
    config.replicatorType = type;
    config.continuous = true;
    config.authenticator = SessionAuthenticator(sessionId);
    return config;
  }

}